Index: drivers/scsi/qla1280.h
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/scsi/qla1280.h,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/scsi/qla1280.h	22 Jul 2004 19:50:06 -0000	1.1
+++ drivers/scsi/qla1280.h	4 Aug 2004 01:29:36 -0000	1.2
@@ -1454,282 +970,143 @@
 /*
  * ISP target entries - Option flags bit definitions.
  */
-#define OF_ENABLE_TAG       BIT_1       /* Tagged queue action enable */
-#define OF_DATA_IN          BIT_6       /* Data in to initiator */
-                                        /*  (data from target to initiator) */
-#define OF_DATA_OUT         BIT_7       /* Data out from initiator */
-                                        /*  (data from initiator to target) */
+#define OF_ENABLE_TAG       BIT_1	/* Tagged queue action enable */
+#define OF_DATA_IN          BIT_6	/* Data in to initiator */
+					/*  (data from target to initiator) */
+#define OF_DATA_OUT         BIT_7	/* Data out from initiator */
+					/*  (data from initiator to target) */
 #define OF_NO_DATA          (BIT_7 | BIT_6)
-#define OF_DISC_DISABLED    BIT_15      /* Disconnects disabled */
-#define OF_DISABLE_SDP      BIT_24      /* Disable sending save data ptr */
-#define OF_SEND_RDP         BIT_26      /* Send restore data pointers msg */
-#define OF_FORCE_DISC       BIT_30      /* Disconnects mandatory */
-#define OF_SSTS             BIT_31      /* Send SCSI status */
-
-#if QL1280_TARGET_MODE_SUPPORT
-/*
- * Target Read/Write buffer structure.
- */
-#define TARGET_DATA_OFFSET  4
-#define TARGET_DATA_SIZE    0x2000      /* 8K */
-#define TARGET_INQ_OFFSET   (TARGET_DATA_OFFSET + TARGET_DATA_SIZE)
-#define TARGET_SENSE_SIZE   18
-#define TARGET_BUF_SIZE     36
-
-typedef struct
-{
-    uint8_t         hdr[4];
-    uint8_t         data[TARGET_DATA_SIZE];
-    struct ident    inq;
-}tgt_t;
-#endif
+#define OF_DISC_DISABLED    BIT_15	/* Disconnects disabled */
+#define OF_DISABLE_SDP      BIT_24	/* Disable sending save data ptr */
+#define OF_SEND_RDP         BIT_26	/* Send restore data pointers msg */
+#define OF_FORCE_DISC       BIT_30	/* Disconnects mandatory */
+#define OF_SSTS             BIT_31	/* Send SCSI status */
+
 
 /*
- * BUS parameters/settings structure
- */
-typedef struct
-{
-    uint8_t     id;                    /* Host adapter SCSI id */
-    uint8_t     bus_reset_delay;       /* SCSI bus reset delay. */
-    uint8_t     failed_reset_count;    /* number of time reset failed */
-	uint8_t     unused;
-    uint16_t    device_enables;        /* Device enable bits. */
-    uint16_t    lun_disables;          /* LUN disable bits. */
-    uint16_t    qtag_enables;          /* Tag queue enables. */
-    uint16_t    hiwat;                 /* High water mark per device. */
-    uint8_t     reset_marker       :1;
-    uint8_t     disable_scsi_reset :1;
-    uint8_t     scsi_bus_dead      :1; /* SCSI Bus is Dead, when 5 back to back resets failed */
+ * BUS parameters/settings structure - UNUSED
+ */
+struct bus_param {
+	uint8_t id;		/* Host adapter SCSI id */
+	uint8_t bus_reset_delay;	/* SCSI bus reset delay. */
+	uint8_t failed_reset_count;	/* number of time reset failed */
+	uint8_t unused;
+	uint16_t device_enables;	/* Device enable bits. */
+	uint16_t lun_disables;	/* LUN disable bits. */
+	uint16_t qtag_enables;	/* Tag queue enables. */
+	uint16_t hiwat;		/* High water mark per device. */
+	uint8_t reset_marker:1;
+	uint8_t disable_scsi_reset:1;
+	uint8_t scsi_bus_dead:1;	/* SCSI Bus is Dead, when 5 back to back resets failed */
+};
+
+
+struct qla_driver_setup {
+	uint32_t no_sync:1;
+	uint32_t no_wide:1;
+	uint32_t no_ppr:1;
+	uint32_t no_nvram:1;
+	uint16_t sync_mask;
+	uint16_t wide_mask;
+	uint16_t ppr_mask;
+};
 
-}bus_param_t;
 
 /*
  * Linux Host Adapter structure
  */
-typedef struct scsi_qla_host
-{
-    /* Linux adapter configuration data */
-    struct Scsi_Host *host;             /* pointer to host data */
-    struct scsi_qla_host   *next;
-    device_reg_t     *iobase;           /* Base Memory-mapped I/O address */
-    uint8_t          pci_bus;
-    uint8_t          pci_device_fn;
-    uint8_t          devnum;
-#if LINUX_VERSION_CODE > KERNEL_VERSION(2,1,95)
-    struct pci_dev *pdev;
+struct scsi_qla_host {
+	/* Linux adapter configuration data */
+	struct Scsi_Host *host;	/* pointer to host data */
+	struct scsi_qla_host *next;
+	struct device_reg *iobase;	/* Base Memory-mapped I/O address */
+
+	unsigned char *mmpbase;	/* memory mapped address */
+	unsigned long host_no;
+	unsigned long instance;
+	struct pci_dev *pdev;
+	uint32_t device_id;
+	uint8_t pci_bus;
+	uint8_t pci_device_fn;
+	uint8_t devnum;
+	uint8_t revision;
+	uint8_t ports;
+
+	unsigned long actthreads;
+	unsigned long isr_count;	/* Interrupt count */
+	unsigned long spurious_int;
+
+	/* Outstandings ISP commands. */
+	struct srb *outstanding_cmds[MAX_OUTSTANDING_COMMANDS];
+
+	/* BUS configuration data */
+	struct bus_param bus_settings[MAX_BUSES];
+
+#if 0
+	/* bottom half run queue */
+	struct tq_struct run_qla_bh;
 #endif
-    volatile unsigned char  *mmpbase;      /* memory mapped address */
-    unsigned long            host_no;
-    unsigned long            instance;
-    uint8_t           revision;
-    uint8_t           ports;
-#if LINUX_VERSION_CODE > KERNEL_VERSION(2,1,0)
-    spinlock_t               spin_lock;
-#endif
-    volatile unsigned char   cpu_lock_count[NR_CPUS];
-    unsigned long            actthreads;
-    unsigned long            qthreads;
-    unsigned long            isr_count;        /* Interrupt count */
-    unsigned long            spurious_int;
-
-    uint32_t           device_id;
-
-    /* Outstandings ISP commands. */
-    srb_t           *outstanding_cmds[MAX_OUTSTANDING_COMMANDS];
 
-    /* BUS configuration data */
-    bus_param_t bus_settings[MAX_BUSES];
-
-    /* Device LUN queues. */
-    scsi_lu_t       *dev[MAX_EQ];      /* Logical unit queues */
+	/* Received ISP mailbox data. */
+	volatile uint16_t mailbox_out[MAILBOX_REGISTER_COUNT];
 
 #ifdef UNUSED
-    /* Interrupt lock, and data */
-    uint8_t          intr_lock;         /* Lock for interrupt locking */
+	struct timer_list dev_timer[MAX_TARGETS];
 #endif
 
-    /* bottom half run queue */
-    struct tq_struct run_qla_bh;
-
-    /* Received ISP mailbox data. */
-    volatile uint16_t mailbox_out[MAILBOX_REGISTER_COUNT];
-
-#ifdef UNUSED
-    /* ISP ring lock, rings, and indexes */
-    uint8_t          ring_lock;         /* ISP ring lock */
-    struct timer_list        dev_timer[MAX_TARGETS];
+	dma_addr_t request_dma;		/* Physical Address */
+	request_t *request_ring;	/* Base virtual address */
+	request_t *request_ring_ptr;	/* Current address. */
+	uint16_t req_ring_index;	/* Current index. */
+	uint16_t req_q_cnt;		/* Number of available entries. */
+
+	dma_addr_t response_dma;	/* Physical address. */
+	struct response *response_ring;	/* Base virtual address */
+	struct response *response_ring_ptr;	/* Current address. */
+	uint16_t rsp_ring_index;	/* Current index. */
+
+#if WATCHDOGTIMER
+	/* Watchdog queue, lock and total timer */
+	uint8_t watchdog_q_lock;	/* Lock for watchdog queue */
+	struct srb *wdg_q_first;	/* First job on watchdog queue */
+	struct srb *wdg_q_last;	/* Last job on watchdog queue */
+	uint32_t total_timeout;	/* Total timeout (quantum count) */
+	uint32_t watchdogactive;
 #endif
 
-    request_t       req[REQUEST_ENTRY_CNT+1];
-    response_t      res[RESPONSE_ENTRY_CNT+1];
-    unsigned long   request_dma;        /* Physical address. */
-    request_t       *request_ring;      /* Base virtual address */
-    request_t       *request_ring_ptr;  /* Current address. */
-    uint16_t        req_ring_index;     /* Current index. */
-    uint16_t        req_q_cnt;          /* Number of available entries. */
-
-    unsigned long   response_dma;       /* Physical address. */
-    response_t      *response_ring;     /* Base virtual address */
-    response_t      *response_ring_ptr; /* Current address. */
-    uint16_t        rsp_ring_index;     /* Current index. */
-
-#if QL1280_TARGET_MODE_SUPPORT
-    /* Target buffer and sense data. */
-    uint32_t        tbuf_dma;           /* Physical address. */
-    tgt_t           *tbuf;
-    uint32_t        tsense_dma;         /* Physical address. */
-    uint8_t         *tsense;
-#endif
+	struct srb *done_q_first;	/* First job on done queue */
+	struct srb *done_q_last;	/* Last job on done queue */
 
-#if  WATCHDOGTIMER
-    /* Watchdog queue, lock and total timer */
-    uint8_t          watchdog_q_lock;   /* Lock for watchdog queue */
-    srb_t           *wdg_q_first;       /* First job on watchdog queue */
-    srb_t           *wdg_q_last;        /* Last job on watchdog queue */
-    uint32_t         total_timeout;     /* Total timeout (quantum count) */
-    uint32_t         watchdogactive;
-#endif
-
-    srb_t           *done_q_first;       /* First job on done queue */
-    srb_t           *done_q_last;        /* Last job on done queue */
+	struct completion *mailbox_wait;
 
-    volatile struct
-    {
-        uint32_t     watchdog_enabled        :1;   /* 0 */
-        uint32_t     mbox_int                :1;   /* 1 */
-        uint32_t     mbox_busy               :1;   /* 2 */
-        uint32_t     online                  :1;   /* 3 */
-        uint32_t     reset_marker            :1;   /* 4 */
-        uint32_t     isp_abort_needed        :1;   /* 5 */
-        uint32_t     pci_64bit_slot          :1;   /* 6 */
-        uint32_t     disable_host_adapter    :1;   /* 7 */
-        uint32_t     reset_active            :1;   /* 8 */
-        uint32_t     abort_isp_active        :1;   /* 9 */
-        uint32_t     disable_risc_code_load  :1;   /* 10 */
-        uint32_t     enable_64bit_addressing :1;   /* 11 */
-#define QLA1280_IN_ISR_BIT      12
-        uint32_t     in_isr                  :1;   /* 12 */
-        uint32_t     in_abort                :1;   /* 13 */
-        uint32_t     in_reset                :1;   /* 14 */
-       uint32_t     dpc                     :1;   /* 15 */
-       uint32_t     dpc_sched               :1;   /* 16 */
-       uint32_t     interrupts_on               :1;   /* 17 */
-    }flags;
+	volatile struct {
+		uint32_t mbox_busy:1;			/* 0 */
+		uint32_t online:1;			/* 1 */
+		uint32_t reset_marker:1;		/* 2 */
+		uint32_t disable_host_adapter:1;	/* 4 */
+		uint32_t reset_active:1;		/* 5 */
+		uint32_t abort_isp_active:1;		/* 6 */
+		uint32_t disable_risc_code_load:1;	/* 7 */
+		uint32_t enable_64bit_addressing:1;	/* 8 */
+		uint32_t in_reset:1;			/* 9 */
+		uint32_t ints_enabled:1;
+		uint32_t ignore_nvram:1;
+#ifdef __ia64__
+		uint32_t use_pci_vchannel:1;
+#endif
+	} flags;
 
-}scsi_qla_host_t;
+	struct nvram nvram;
+	int nvram_valid;
+};
 
 /*
  * Macros to help code, maintain, etc.
  */
-#define SUBDEV(b, t, l)  ( (b << (MAX_T_BITS + MAX_L_BITS)) | (t << MAX_L_BITS) | l)
-#define LU_Q(ha, b, t, l)  (ha->dev[SUBDEV(b, t, l)])
-
-/*
- * Locking Macro Definitions
- *
- * LOCK/UNLOCK definitions are lock/unlock primitives for multi-processor
- * or spl/splx for uniprocessor.
- */
-#define QLA1280_HIER   HBA_HIER_BASE  /* Locking hierarchy base for hba */
-
-#define QLA1280_WATCHDOG_Q_LOCK(ha, p)   
-#define QLA1280_WATCHDOG_Q_UNLOCK(ha, p) 
-
-#define QLA1280_SCSILU_LOCK(q)  
-#define QLA1280_SCSILU_UNLOCK(q) 
-
-#define QLA1280_INTR_LOCK(ha)
-#define QLA1280_INTR_UNLOCK(ha)     
+#define SUBDEV(b, t, l)		((b << (MAX_T_BITS + MAX_L_BITS)) | (t << MAX_L_BITS) | l)
+#define LU_Q(ha, b, t, l)	(ha->dev[SUBDEV(b, t, l)])
 
-#define QLA1280_RING_LOCK(ha)  
-#define QLA1280_RING_UNLOCK(ha)   
-
-#if defined(__cplusplus)
-}
-#endif
-/*
- *  Linux - SCSI Driver Interface Function Prototypes.
- */
-int qla1280_proc_info ( char *, char **, off_t, int, int, int);
-const char * qla1280_info(struct Scsi_Host *host);
-int qla1280_detect(Scsi_Host_Template *);
-int qla1280_release(struct Scsi_Host *);
-const char * qla1280_info(struct Scsi_Host *);
-int qla1280_queuecommand(Scsi_Cmnd *, void (* done)(Scsi_Cmnd *));
-int qla1280_abort(Scsi_Cmnd *);
-int qla1280_reset(Scsi_Cmnd *, unsigned int);
-int qla1280_biosparam(Disk *, kdev_t, int[]);
-void qla1280_intr_handler(int, void *, struct pt_regs *);
-void qla1280_setup(char *s, int *dummy);
-#if defined(__386__)
-#  define QLA1280_BIOSPARAM  qla1280_biosparam
-#else
-#  define QLA1280_BIOSPARAM  NULL
-#endif
-
-/*
- * Scsi_Host_template (see hosts.h) 
- * Device driver Interfaces to mid-level SCSI driver.
- */
-#if LINUX_VERSION_CODE < KERNEL_VERSION(2,1,95)
-/* This interface is now obsolete !!! */ 
-#define QLA1280_LINUX_TEMPLATE {		                 \
-        next:           NULL,                                    \
-        usage_count:    NULL,                                    \
-	proc_dir:		NULL,          	                 \
-	proc_info:		NULL,	                         \
-	name:			"Qlogic ISP 1280",               \
-	detect:			qla1280_detect,	                 \
-	release:		qla1280_release,                 \
-	info:			qla1280_info,	                 \
-        command:        NULL,                                    \
-	queuecommand:	qla1280_queuecommand,	                 \
-	abort:			qla1280_abort,	                 \
-	reset:			qla1280_reset,	                 \
-        slave_attach:   NULL,                                    \
-	bios_param:		QLA1280_BIOSPARAM,               \
-	can_queue:		255, /* MAX_OUTSTANDING_COMMANDS */   \
-	this_id:		-1,  /* scsi id of host adapter */        \
-	sg_tablesize:	SG_ALL,	 \
-	cmd_per_lun:	3,	  /* max commands per lun */	       \
-	present:	    0,    /* number of 1280s present */	       \
-	unchecked_isa_dma: 0, /* no memeory DMA restrictions */    \
-	use_clustering:	ENABLE_CLUSTERING			               \
-}
-#else
-
-#define QLA1280_LINUX_TEMPLATE {		                 \
-	next: NULL,						\
-	module: NULL,						\
-	proc_dir: NULL,						\
-	proc_info: qla1280_proc_info,				\
-	name:			"Qlogic ISP 1280\1080",               \
-	detect: qla1280_detect,					\
-	release: qla1280_release,				\
-	info: qla1280_info,					\
-	ioctl: NULL,						\
-	command: NULL,						\
-	queuecommand: qla1280_queuecommand,			\
-	eh_strategy_handler: NULL,				\
-	eh_abort_handler: NULL,					\
-	eh_device_reset_handler: NULL,				\
-	eh_bus_reset_handler: NULL,				\
-	eh_host_reset_handler: NULL,				\
-	abort: qla1280_abort,					\
-	reset: qla1280_reset,					\
-	slave_attach: NULL,					\
-	bios_param: QLA1280_BIOSPARAM,				\
-	can_queue: 255,		/* max simultaneous cmds      */\
-	this_id: -1,		/* scsi id of host adapter    */\
-	sg_tablesize: SG_ALL,	/* max scatter-gather cmds    */\
-	cmd_per_lun: 3,		/* cmds per lun (linked cmds) */\
-	present: 0,		/* number of 7xxx's present   */\
-	unchecked_isa_dma: 0,	/* no memory DMA restrictions */\
-	use_clustering: ENABLE_CLUSTERING,			\
-	use_new_eh_code: 0,					\
-	emulated: 0					        \
-}
-#endif
+#endif				/* HOSTS_C */
 
 
-#endif /* _IO_HBA_QLA1280_H */
+#endif				/* _IO_HBA_QLA1280_H */
Index: drivers/scsi/qlogicfas.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/scsi/qlogicfas.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/scsi/qlogicfas.c	22 Jul 2004 19:50:02 -0000	1.1
+++ drivers/scsi/qlogicfas.c	4 Aug 2004 01:29:36 -0000	1.2
@@ -111,10 +111,6 @@
 
 #include <linux/module.h>
 
-#ifdef PCMCIA
-#undef MODULE
-#endif 
-
 #include <linux/blk.h>	/* to get disk capacity */
 #include <linux/kernel.h>
 #include <linux/string.h>
@@ -131,6 +127,10 @@
 #include "qlogicfas.h"
 #include <linux/stat.h>
 
+#ifdef PCMCIA
+#undef MODULE
+#endif 
+
 /*----------------------------------------------------------------*/
 /* driver state info, local to driver */
 static int	    qbase;	/* Port */
@@ -647,7 +647,7 @@
 	if(request_irq(qlirq, do_ql_ihandl, SA_SHIRQ, "qlogicfas", hreg) < 0)
 #endif	
 	{
-		scsi_unregister(host);
+		scsi_unregister(hreg);
 		goto err_release_mem;
 	}
 #endif
@@ -717,7 +717,9 @@
 }
 MODULE_LICENSE("GPL");
 
+#ifndef PCMCIA
 /* Eventually this will go into an include file, but this will be later */
 static Scsi_Host_Template driver_template = QLOGICFAS;
 #include "scsi_module.c"
+#endif
 
Index: drivers/scsi/qlogicfc.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/scsi/qlogicfc.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/scsi/qlogicfc.c	22 Jul 2004 19:50:01 -0000	1.1
+++ drivers/scsi/qlogicfc.c	4 Aug 2004 01:29:36 -0000	1.2
@@ -27,12 +27,12 @@
  */
 
 /*
- * $Date: 2004/07/22 19:50:01 $
- * $Revision: 1.1 $
+ * $Date: 2004/08/04 01:29:36 $
+ * $Revision: 1.2 $
  *
  * $Log: qlogicfc.c,v $
- * Revision 1.1  2004/07/22 19:50:01  joff
- * Initial revision
+ * Revision 1.2  2004/08/04 01:29:36  joff
+ * merging 2.4.26-vrs1
  *
  * Revision 0.5  1995/09/22  02:23:15  root
  * do auto request sense
@@ -414,7 +414,7 @@
    if that mbox should be copied as input.  For example 0x2 would mean
    only copy mbox1. */
 
-const u_char mbox_param[] =
+static const u_char mbox_param[] =
 {
 	0x01,			/* MBOX_NO_OP */
 	0x1f,			/* MBOX_LOAD_RAM */
Index: drivers/scsi/qlogicfc.h
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/scsi/qlogicfc.h,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/scsi/qlogicfc.h	22 Jul 2004 19:50:01 -0000	1.1
+++ drivers/scsi/qlogicfc.h	4 Aug 2004 01:29:37 -0000	1.2
@@ -23,12 +23,12 @@
 
 
 /*
- * $Date: 2004/07/22 19:50:01 $
- * $Revision: 1.1 $
+ * $Date: 2004/08/04 01:29:37 $
+ * $Revision: 1.2 $
  *
  * $Log: qlogicfc.h,v $
- * Revision 1.1  2004/07/22 19:50:01  joff
- * Initial revision
+ * Revision 1.2  2004/08/04 01:29:37  joff
+ * merging 2.4.26-vrs1
  *
  * Revision 0.5  1995/09/22  02:32:56  root
  * do auto request sense
Index: drivers/scsi/qlogicisp.h
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/scsi/qlogicisp.h,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/scsi/qlogicisp.h	22 Jul 2004 19:50:02 -0000	1.1
+++ drivers/scsi/qlogicisp.h	4 Aug 2004 01:29:37 -0000	1.2
@@ -17,12 +17,12 @@
 /* Renamed and updated to 1.3.x by Michael Griffith <grif@cs.ucr.edu> */
 
 /*
- * $Date: 2004/07/22 19:50:02 $
- * $Revision: 1.1 $
+ * $Date: 2004/08/04 01:29:37 $
+ * $Revision: 1.2 $
  *
  * $Log: qlogicisp.h,v $
- * Revision 1.1  2004/07/22 19:50:02  joff
- * Initial revision
+ * Revision 1.2  2004/08/04 01:29:37  joff
+ * merging 2.4.26-vrs1
  *
  * Revision 0.5  1995/09/22  02:32:56  root
  * do auto request sense
Index: drivers/scsi/qlogicpti.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/scsi/qlogicpti.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/scsi/qlogicpti.c	22 Jul 2004 19:50:02 -0000	1.1
+++ drivers/scsi/qlogicpti.c	4 Aug 2004 01:29:37 -0000	1.2
@@ -53,7 +53,7 @@
 
 #define PACKB(a, b)			(((a)<<4)|(b))
 
-const u_char mbox_param[] = {
+static const u_char mbox_param[] = {
 	PACKB(1, 1),	/* MBOX_NO_OP */
 	PACKB(5, 5),	/* MBOX_LOAD_RAM */
 	PACKB(2, 0),	/* MBOX_EXEC_FIRMWARE */
Index: drivers/scsi/scsi.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/scsi/scsi.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/scsi/scsi.c	22 Jul 2004 19:50:05 -0000	1.1
+++ drivers/scsi/scsi.c	4 Aug 2004 01:29:37 -0000	1.2
@@ -84,7 +84,7 @@
 #endif
 
 /*
-   static const char RCSid[] = "$Header: /cvsroot/ts-7200/dist/linux24/drivers/scsi/scsi.c,v 1.1 2004/07/22 19:50:05 joff Exp $";
+   static const char RCSid[] = "$Header: /cvsroot/ts-7200/dist/linux24/drivers/scsi/scsi.c,v 1.2 2004/08/04 01:29:37 joff Exp $";
  */
 
 /*
@@ -197,6 +197,7 @@
 
 	blk_init_queue(q, scsi_request_fn);
 	blk_queue_headactive(q, 0);
+	blk_queue_throttle_sectors(q, 1);
 	q->queuedata = (void *) SDpnt;
 }
 
Index: drivers/scsi/scsi.h
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/scsi/scsi.h,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/scsi/scsi.h	22 Jul 2004 19:50:05 -0000	1.1
+++ drivers/scsi/scsi.h	4 Aug 2004 01:29:37 -0000	1.2
@@ -610,6 +610,7 @@
 	unsigned remap:1;	/* support remapping  */
 	unsigned starved:1;	/* unable to process commands because
 				   host busy */
+	unsigned no_start_on_add:1;	/* do not issue start on add */
 
 	// Flag to allow revalidate to succeed in sd_open
 	int allow_revalidate;
Index: drivers/scsi/scsi_error.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/scsi/scsi_error.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/scsi/scsi_error.c	22 Jul 2004 19:50:03 -0000	1.1
+++ drivers/scsi/scsi_error.c	4 Aug 2004 01:29:37 -0000	1.2
@@ -78,7 +78,7 @@
 #define HOST_RESET_SETTLE_TIME  10*HZ
 
 
-static const char RCSid[] = "$Header: /cvsroot/ts-7200/dist/linux24/drivers/scsi/scsi_error.c,v 1.1 2004/07/22 19:50:03 joff Exp $";
+static const char RCSid[] = "$Header: /cvsroot/ts-7200/dist/linux24/drivers/scsi/scsi_error.c,v 1.2 2004/08/04 01:29:37 joff Exp $";
 
 STATIC int scsi_check_sense(Scsi_Cmnd * SCpnt);
 STATIC int scsi_request_sense(Scsi_Cmnd *);
@@ -119,25 +119,13 @@
 		    int timeout,
 		    void (*complete) (Scsi_Cmnd *))
 {
-
-	/*
-	 * If the clock was already running for this command, then
-	 * first delete the timer.  The timer handling code gets rather
-	 * confused if we don't do this.
-	 */
-	if (SCset->eh_timeout.function != NULL) {
-		del_timer(&SCset->eh_timeout);
-	}
 	SCset->eh_timeout.data = (unsigned long) SCset;
-	SCset->eh_timeout.expires = jiffies + timeout;
 	SCset->eh_timeout.function = (void (*)(unsigned long)) complete;
+	mod_timer(&SCset->eh_timeout, jiffies + timeout);
 
 	SCset->done_late = 0;
 
 	SCSI_LOG_ERROR_RECOVERY(5, printk("Adding timer for command %p at %d (%p)\n", SCset, timeout, complete));
-
-	add_timer(&SCset->eh_timeout);
-
 }
 
 /*
Index: drivers/scsi/scsi_ioctl.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/scsi/scsi_ioctl.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/scsi/scsi_ioctl.c	22 Jul 2004 19:50:07 -0000	1.1
+++ drivers/scsi/scsi_ioctl.c	4 Aug 2004 01:29:37 -0000	1.2
@@ -302,6 +302,7 @@
 		cmd[1] = (cmd[1] & 0x1f) | (dev->lun << 5);
 
 	switch (opcode) {
+	case SEND_DIAGNOSTIC:
 	case FORMAT_UNIT:
 		timeout = FORMAT_UNIT_TIMEOUT;
 		retries = 1;
Index: drivers/scsi/scsi_lib.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/scsi/scsi_lib.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/scsi/scsi_lib.c	22 Jul 2004 19:50:01 -0000	1.1
+++ drivers/scsi/scsi_lib.c	4 Aug 2004 01:29:37 -0000	1.2
@@ -402,6 +402,7 @@
 		if ((bh = req->bh) != NULL) {
 			nsect = bh->b_size >> 9;
 			blk_finished_io(nsect);
+			blk_finished_sectors(req, nsect);
 			req->bh = bh->b_reqnext;
 			bh->b_reqnext = NULL;
 			sectors -= nsect;
@@ -428,6 +429,14 @@
 	 */
 	if (req->bh) {
 		/*
+		 * Recount segments whether we are immediately going to
+		 * requeue the command or not, other code might requeue
+		 * it later and since we changed the segment count up above,
+		 * we need it updated.
+		 */
+		recount_segments(SCpnt);
+
+		/*
 		 * Bleah.  Leftovers again.  Stick the leftovers in
 		 * the front of the queue, and goose the queue again.
 		 */
@@ -998,15 +1007,6 @@
 			 */
 			if( req->special != NULL ) {
 				SCpnt = (Scsi_Cmnd *) req->special;
-				/*
-				 * We need to recount the number of
-				 * scatter-gather segments here - the
-				 * normal case code assumes this to be
-				 * correct, as it would be a performance
-				 * lose to always recount.  Handling
-				 * errors is always unusual, of course.
-				 */
-				recount_segments(SCpnt);
 			} else {
 				SCpnt = scsi_allocate_device(SDpnt, FALSE, FALSE);
 			}
Index: drivers/scsi/scsi_obsolete.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/scsi/scsi_obsolete.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/scsi/scsi_obsolete.c	22 Jul 2004 19:50:02 -0000	1.1
+++ drivers/scsi/scsi_obsolete.c	4 Aug 2004 01:29:37 -0000	1.2
@@ -71,7 +71,7 @@
 #undef USE_STATIC_SCSI_MEMORY
 
 /*
-   static const char RCSid[] = "$Header: /cvsroot/ts-7200/dist/linux24/drivers/scsi/scsi_obsolete.c,v 1.1 2004/07/22 19:50:02 joff Exp $";
+   static const char RCSid[] = "$Header: /cvsroot/ts-7200/dist/linux24/drivers/scsi/scsi_obsolete.c,v 1.2 2004/08/04 01:29:37 joff Exp $";
  */
 
 
Index: drivers/scsi/scsi_queue.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/scsi/scsi_queue.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/scsi/scsi_queue.c	22 Jul 2004 19:50:02 -0000	1.1
+++ drivers/scsi/scsi_queue.c	4 Aug 2004 01:29:37 -0000	1.2
@@ -54,7 +54,7 @@
  *      7) Don't send down any more commands if the host/device is busy.
  */
 
-static const char RCSid[] = "$Header: /cvsroot/ts-7200/dist/linux24/drivers/scsi/scsi_queue.c,v 1.1 2004/07/22 19:50:02 joff Exp $";
+static const char RCSid[] = "$Header: /cvsroot/ts-7200/dist/linux24/drivers/scsi/scsi_queue.c,v 1.2 2004/08/04 01:29:37 joff Exp $";
 
 
 /*
